      implicit real*8(a-h,o-z)
      real*4 row,t1,p1,dc,errc
      real*4 theta,phi,seck,uref,fmid,om,band,cref
      real*4 snrbest, snrsv, deldif, delta
      character*256 filenam2
      character*4 nsta
      character*8 stat
      character*1 wavetype
      character*7 cmtname
      character*160 string
      dimension block(50000)
      common/bits/fmid,band,uref,cref
      common row(50000),nrow(50000)
      data pi/3.14159265358979d0/
      rad=pi/180.d0   
      call blks(nblk)
      area=4.*pi/nblk*.01
      write(*,'(a,$)') 'output matrix name: '
      read(*,'(a256)') filenam2
      open(10,file=filenam2, form='unformatted')


      print *,'enter center frequency in mHz and band'
      read(*,*) fmid,band
      fmid=.001*fmid
      band=fmid*band
c      print *,'enter acut'
c      read(*,*) acut
      acut=16.0

      print *,'enter average phase velocity : '
      read(*,*) cref
      inum=0
      print *,'enter phase file name : '
      read(*,'(a)') filenam2
      open(7,file=filenam2)

c*** first line is junk
      read(7,"(a)") string
      nproc=0
      av=0.
c*** loop over rest of file
   15 continue
      read(7,"(a)",end=25) string
      read(string,"(a7,1x,a8,f8.3,f9.3,f6.1,f8.3,f9.3,f8.4,f8.1,f8.3,
     #     1x,f6.3,1x,f6.3,1x,f6.3,1x,a1,3f6.1,f8.3,1x,f5.3,1x,f5.3)")
     #     cmtname,stat,cmtlat,cmtlon,cmtdep,
     #     stlat,stlon,delc,distance,dphase,
     #     wfit,sfit,bfit,wavetype,
     #     period,periodmin,periodmax,predphase,weight,weight2
        if(weight.le.0.) goto 15
        if(weight2.le.0.) goto 15
        om=2.*pi/period
        arg=om*distance*delc/dphase
        if(arg.ge.0.) goto 15
        dc=delc/cref
        errc=cref/(om*distance*weight2)
        nsta(1:4)=stat(1:4)
        if(nsta(4:4).eq.'-') nsta(4:4) =' '
        if(nsta.eq.'PFOT') nsta='PFO '
        if(nsta.eq.'PFO_') nsta='PFO '
        if(nsta.eq.'IPAS') nsta='PAS '
        if(nsta.eq.'GRI ') goto 15
        norb=1
        t0=(90.-cmtlat)*rad
        p0=cmtlon*rad
        t0=geocen(t0)
        read(nsta,'(a4)')jsta
        call allnsta(jsta,t1,p1)
        ts=t1
        ps=p1
        ts=geocen(ts)
        call sray(t0,p0,ts,ps,norb,delt,nblk,acut)
        nels=0
c        sum=0.
        do i=1,nblk
          if(row(i).ne.0.) then
             nels=nels+1
             nrow(nels)=i
             row(nels)=-row(i)*area
c             sum=sum+row(nels)
          end if
        enddo
c        print *,sum*100
c        av=av+abs(sum*100.-1.)

        nscan=nels
        inum=inum+1
c        if(inum.eq.50) then
c          av=av/50.
c           print *,av
c           goto 25
c        endif
        write(10) dc,errc,nscan
        write(10) (row(i),i=1,nscan)
        write(10) (nrow(i),i=1,nscan) 
      goto 15
   25 close(7)
      close(10)
      print *,inum
      stop
      end

      subroutine sray(sth,sph,rth,rph,norb,delt,nblk,acut)
      implicit real*8(a-h,o-z)
      real*4 row,fmid,band,uref,cref,dist,r0,t0,p0
      real*4 om1,om2,arg,fres
      common/bits/fmid,band,uref,cref
      common row(50000),nrow(50000)
      data pi/3.14159265358979d0/
      r0=6371.
      a=r0
      tpi=2.*pi
      fk=tpi*a/cref
      rad=pi/180.d0   
      tol=rad

      do i=1,nblk
        row(i)=0.
      enddo
      cr=cos(rth)
      sr=sin(rth)
      cs=cos(sth)
      ss=sin(sth)
c  do from source to receiver
      dp=rph-sph
      cd=cr*cs+sr*ss*cos(dp)
      sd=sqrt(1.d0-cd*cd)
      dist=atan2(sd,cd)
      delt=abs(dist)/rad
      do ib=1,nblk
        call iblk(r0,t0,p0,ib)
        t=t0*rad
        p=p0*rad
        c0=cos(t)
        s0=sin(t)
c  do from source to point
        dp=p-sph
        cd1=c0*cs+s0*ss*cos(dp)
        sd1=sqrt(1.d0-cd1*cd1)
        del1=atan2(sd1,cd1)
        if(del1.lt.tol) then
          del1=tol
          sd1=sin(del1)
        end if
c  do from point to receiver
        dp=rph-p
        cd2=c0*cr+s0*sr*cos(dp)
        sd2=sqrt(1.d0-cd2*cd2)
        del2=atan2(sd2,cd2)
        if(del2.lt.tol) then
          del2=tol
          sd2=sin(del2)
        end if
        arg=max(fk*(del1+del2-dist),0.)
c        print *,arg*om,acut
        if(arg*fmid.gt.acut) then
           row(ib)=0.
        else
          gam=sd/(sd1*sd2)
          sg=sqrt(a*gam/cref)
c*** since we multiply by the area of each block, we don't need the sin(theta) term in the kernels
c    area normalization is done in the main program
c          s1=sqrt(cd2*cd2-2.*cd*cd1*cd2+cd1*cd1)/sd
c*** this is for phase
           fn=-sg/(band*dist)
           om1=fmid-band*0.5
           om2=fmid+band*0.5
           row(ib)=fn*(fres(om2,arg)-fres(om1,arg))
c***** this is unaverged  phase (rel)
c          fn=-sg/dist*sqrt(fmid)*sin(fmid*arg+0.25*pi)
c          row(ib)=fn
        end if
      enddo
      return
      end

      function fres(om,fac)
c*** function to evaluate equation (30) of spetzler et al
c*** note that frequencies are in hertz
      data pi/3.14159265358979/
      pi4=0.25*pi
      if(abs(fac*om).lt.1.e-3) then
        fres=sqrt(2.*om**3)/3.*(1.+fac*om*.6)
      else
        arg=sqrt(2.*fac*om/pi)
        if(arg.lt.200.) then
          call frenel(arg,sf,cf)
          fres=sqrt(om/2)*(sin(fac*om)-cos(fac*om))/fac+
     +     sqrt(pi4/(fac**3))*(cf-sf)
        else
          fres=sqrt(om/2)*(sin(fac*om)-cos(fac*om))/fac
        end if
      end if
      return
      end

      subroutine frenel(x,s,c)
c*** compute fresnel sine and cosine integral
c (from numerical recipes)
c      parameter (fpmin=1.e-30,xmin=1.5,maxit=100,eps=6.e-8)
c*** we are not interested in extreme precision
      parameter (fpmin=1.e-30,xmin=1.5,maxit=100,eps=1.e-5)
      data pi/3.14159265358979/
      complex b,cc,d,h,del,cs
      logical odd
      absc(h)=abs(real(h))+abs(aimag(h))
      ax=abs(x)
      if(ax.lt.sqrt(fpmin)) then
        s=0.
        c=ax
      else if(ax.le.xmin) then
c*** ascending series
        sum=0.
        sums=0.
        sumc=ax
        sign=1.
        fact=pi*ax*ax*0.5
        odd=.true.
        term=ax
        n=3
        do k=1,maxit
          term=term*fact/k
          sum=sum+sign*term/n
          test=abs(sum)*eps
          if(odd) then
            sign=-sign
            sums=sum
            sum=sumc
          else
            sumc=sum
            sum=sums
          end if
          if(term.lt.test) goto 1
          odd=.not.odd
          n=n+2
        enddo
        print *,'no convergence in frenel'
        stop
    1   s=sums
        c=sumc
      else
        pix2=pi*ax*ax
        b=cmplx(1.,-pix2)
        cc=1./fpmin
        d=1./b
        h=d
        n=-1
        do k=2,maxit
          n=n+2
          a=-n*(n+1)
          b=b+4.
          d=1./(a*d+b)
          cc=b+a/cc
          del=cc*d
          h=h*del
          if(absc(del-1.).lt.eps) goto 2
        enddo
        print *,'no convergence in frenel'
        stop
    2   h=h*cmplx(ax,-ax)
        cs=cmplx(.5,.5)*(1.-cmplx(cos(.5*pix2),sin(.5*pix2))*h)
        c=real(cs)
        s=aimag(cs)
      end if
      if(x.lt.0.) then
        c=-c
        s=-s
      end if
      return
      end

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename
      data rad/57.29578/
      print *,'enter block descriptor file : '
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat                  
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end

      double precision function geocen(arg)
c Returns geocentric colat given geographic colat as arg (n.b. fac=(1-f)**c
c argument in radians.
      implicit real*8(a-h,o-z)
      data pi2,fac/1.570796326794895d0,0.993305621334896d0/
      geocen=pi2-datan(fac*dcos(arg)/dmax1(1.d-200,dsin(arg)))
      return
      end

      subroutine iblk(r0,t0,p0,ib)
c*** routine to find radius,colat and long of middle of block ib
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      kshell=float((ib-1))/float(mshell)+1
      r0=0.5*(r1(kshell)+r2(kshell))
      do 10 i=1,nlat
        j1=(kshell-1)*mshell+mlat(i)+1
        j2=(kshell-1)*mshell+mlat(i+1)
        if(ib.ge.j1.and.ib.le.j2) then
          t0=(i-0.5)*bsz
          p0=(ib-j1+0.5)*hsz(i)
          return
        end if
   10 continue
      r0=-1
      return
      end

      subroutine allnsta(nsta,th,ph)
      parameter(lsta=10000)
      character*2 dtype(lsta)
      character*40 dname(lsta)
      integer*4 dsta(lsta)
      dimension dlat(lsta),dlon(lsta),delev(lsta)
      dimension ddep(lsta)
      save
      data rad,ifirs/.017453293,0/
      th=0.
      ph=0.
      istat=0
      if(ifirs.eq.1)goto 1
  
      open(51,file='stations',status='old')
      j=0
 2    continue
      j=j+1
      read(51,101,end=99)dsta(j),dtype(j),dlat(j),
     +     dlon(j),delev(j),ddep(j),dname(j)
      if(dlon(j).lt.0.)dlon(j)=dlon(j)+360.
      goto 2
 99   continue
      close(51)
      ifirs=1
      ndat=j-1
 1    continue
      do 10 i=1,ndat
      if(nsta.eq.dsta(i))then
          istat=1  
          th=rad*(90.-dlat(i))
          ph=rad*dlon(i)
          return
      endif
 10   continue
      print 100,' station not found: ',nsta
 101  format(a4,4x,a2,3x,2f11.4,f8.0,f5.0,17x,a40)
 100  format(a,a4,1x,a4)
      return
      end

