      character*256 filename
      dimension kmat(90000),row(90000)
      dimension block(90000)

c*** get block structure
      call blks(nblk)
      do i=1,nblk
        block(i)=0.0001
      enddo

      print *,'how many matrix files'
      read(*,*) nfiles

      do ijk=1,nfiles
         write(*,'(a,$)') 'enter matrix file name: '
         read(*,'(a256)') filename
         open(10,file=filename, form='unformatted')

   20   read(10,end=30) rem,reserr,nscan
        read(10) (row(i),i=1,nscan)
        read(10) (kmat(i),i=1,nscan)
         do i=1,nscan
           block(kmat(i))=block(kmat(i))+1.
         enddo
        goto 20
   30    continue         
      close(10)
      enddo
      open(9,file='blkcnt.out',form='unformatted')
      iter=1
      phibar=0.
      r=0.
      n=nblk
      write(9) nblk,phibar
        write(9) iter,(block(i),i=1,n),phibar,r
      close(9)
      stop
      end

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename
      data rad/57.29578/
      print *,'enter block descriptor file : '
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end



