      open(8,file='world.coast')
      open(9,file='aitoff')
 5    read(8,*,end=90)xlon,xlat
      if(xlon.gt.500..or.xlat.gt.500.)then
        x=1.1
        y=-90.1
        goto 10
      endif
      cen=-180.
      call aitoff(xlat,xlon,x,y,cen)
 10   write(9,'(2f11.5)') x,y
      goto 5
 90   continue
      close(8)
      close(9)
      end

      subroutine aitoff(lat, lon, x, y,cen)
c$$$$ calls no other routines
c  Maps latitude, longitude into Aitoff's equal-area projection.
c  The sphere is mapped into an ellipse, major semi-axis 2, minor
c  semi-axis 1; the equator is imaged into the major axis, the
c  Greenwhich meridian into the minor axis.  The origin (0, 0),
c  where the axes cross, may be moved to longitude  phi0  by
c     call aitoff(lat, lon-phi0, x, y)
c
      real lat, lon
      data degby2/0.008726646/, deg/0.0174532925/
c
      flon=lon-cen
      clat=cos(deg*lat)
      half=degby2*(mod(flon+180.0, 360.0) - 180.0)
      R=sqrt(1.0/(abs(1.0 + clat*cos(half)) + 1.0e-15))
      x=2.0*R*clat*sin(half)*90+180
      y=R*sin(deg*lat)*90
      return
      end


c      subroutine aitoff(xlat,xlon,x,y)
cc     input longitude has to go from 0 to
cc     360 deg
c      
c      data pi/3.1415926536/
c      data rad/1.7453293e-02/
c      data fudge/1.11/
c      xl=xlon
c      if(xlon.lt.0.) xl=xl+360.
c      
c      xlar=rad*xlat
c      xlor=.5*rad*(xlon-180.)
c      sinla=sin(xlar)
c      cosla=sqrt(1.-sinla*sinla)
c      sinph=sin(xlor)
c      cosph=sqrt(1.-sinph*sinph)
c      cosa=cosph*cosla
c      rr=1.414214/sqrt(1.+cosa)
c      x=2.*(cosla-cosa*cosph)*rr
c      if(sinph.ne.0) x=x/sinph
c      x=x*57.29578*fudge+180.
c      y=sinla*rr*57.29578*fudge
c      return
c      end

c      subroutine aitoff0(xlat,xlon,x,y)
cc     input longitude has to go from -180 to
cc     180 deg
c      
c      data pi/3.1415926536/
c      data rad/1.7453293e-02/
c      data fudge/1.11/
c      xl=xlon
c      if(xl.gt.180.) xl=xl-180.
c      if(xl.lt.-180.) xl=xl+180.      
c      xlar=rad*xlat
c      xlor=.5*rad*xl
c      sinla=sin(xlar)
c      cosla=sqrt(1.-sinla*sinla)
c      sinph=sin(xlor)
c      cosph=sqrt(1.-sinph*sinph)
c      cosa=cosph*cosla
c      rr=1.414214/sqrt(1.+cosa)
c      x=2.*(cosla-cosa*cosph)*rr
c      if(sinph.ne.0) x=x/sinph
c      x=x*57.29578*fudge
c      y=sinla*rr*57.29578*fudge
c      return
c      end
